searchData={"content_type":"text/markdown","items":[{"doc":"`Actors` It's the client API for the Spawn actors.\nThrough this module we interact with the actors by creating,\ninvoking or configuring them.","ref":"Actors.html","title":"Actors","type":"module"},{"doc":"","ref":"Actors.html#get_state/1","title":"Actors.get_state/1","type":"function"},{"doc":"Makes a request to an actor.\n\n  * `request` - The InvocationRequest\n  * `opts` - The options to Invoke Actors\n##","ref":"Actors.html#invoke/2","title":"Actors.invoke/2","type":"function"},{"doc":"Makes a request to an actor using Nats broker.\n\n  * `request` - The InvocationRequest\n  * `opts` - The options to Invoke Actors\n##","ref":"Actors.html#invoke_with_nats/2","title":"Actors.invoke_with_nats/2","type":"function"},{"doc":"","ref":"Actors.html#invoke_with_span/2","title":"Actors.invoke_with_span/2","type":"function"},{"doc":"Registers all actors defined in HostActor.\n\n  * `registration` - The RegistrationRequest\n  * `opts` - The options to create Actors\n##","ref":"Actors.html#register/2","title":"Actors.register/2","type":"function"},{"doc":"Spawn actors defined in HostActor.\n\n  * `registration` - The SpawnRequest\n  * `opts` - The options to create Actors\n\nspawn_actor must be used when you want to create a concrete instance of an actor\npreviously registered as unamed.\nThat is, when an Actorid is associated with an actor of unamed type.\nThis function only registers the metadata of the new actor, not activating it.\nThis will occur when the sprite is first invoked.\n##","ref":"Actors.html#spawn_actor/2","title":"Actors.spawn_actor/2","type":"function"},{"doc":"","ref":"Actors.html#try_reactivate_actor/3","title":"Actors.try_reactivate_actor/3","type":"function"},{"doc":"`Entity` controls the entire lifecycle of the Host Actor.","ref":"Actors.Actor.Entity.html","title":"Actors.Actor.Entity","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Actors.Actor.Entity.html#child_spec/1","title":"Actors.Actor.Entity.child_spec/1","type":"function"},{"doc":"Retrieve the Actor state direct from memory.","ref":"Actors.Actor.Entity.html#get_state/2","title":"Actors.Actor.Entity.get_state/2","type":"function"},{"doc":"Synchronously invokes an Action on an Actor.","ref":"Actors.Actor.Entity.html#invoke/3","title":"Actors.Actor.Entity.invoke/3","type":"function"},{"doc":"Asynchronously invokes an Action on an Actor.","ref":"Actors.Actor.Entity.html#invoke_async/3","title":"Actors.Actor.Entity.invoke_async/3","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.html#start_link/1","title":"Actors.Actor.Entity.start_link/1","type":"function"},{"doc":"`EntityState` Represents the internal state of an Actor.","ref":"Actors.Actor.Entity.EntityState.html","title":"Actors.Actor.Entity.EntityState","type":"module"},{"doc":"","ref":"Actors.Actor.Entity.EntityState.html#pack/1","title":"Actors.Actor.Entity.EntityState.pack/1","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.EntityState.html#unpack/1","title":"Actors.Actor.Entity.EntityState.unpack/1","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.EntityState.html#t:t/0","title":"Actors.Actor.Entity.EntityState.t/0","type":"type"},{"doc":"Handles Invocation functions for Actor Entity\nAll the public functions here assumes they are executing inside a GenServer","ref":"Actors.Actor.Entity.Invocation.html","title":"Actors.Actor.Entity.Invocation","type":"module"},{"doc":"","ref":"Actors.Actor.Entity.Invocation.html#broadcast_invoke/2","title":"Actors.Actor.Entity.Invocation.broadcast_invoke/2","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Invocation.html#broadcast_invoke/4","title":"Actors.Actor.Entity.Invocation.broadcast_invoke/4","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Invocation.html#do_broadcast/3","title":"Actors.Actor.Entity.Invocation.do_broadcast/3","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Invocation.html#do_side_effects/2","title":"Actors.Actor.Entity.Invocation.do_side_effects/2","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Invocation.html#handle_timers/1","title":"Actors.Actor.Entity.Invocation.handle_timers/1","type":"function"},{"doc":"Invoke function, receives a request and calls invoke host with the response","ref":"Actors.Actor.Entity.Invocation.html#invoke/2","title":"Actors.Actor.Entity.Invocation.invoke/2","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Invocation.html#invoke_init/1","title":"Actors.Actor.Entity.Invocation.invoke_init/1","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Invocation.html#timer_invoke/2","title":"Actors.Actor.Entity.Invocation.timer_invoke/2","type":"function"},{"doc":"Handles lifecycle functions for Actor Entity\nAll the public functions here assumes they are executing inside a GenServer","ref":"Actors.Actor.Entity.Lifecycle.html","title":"Actors.Actor.Entity.Lifecycle","type":"module"},{"doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#deactivate/1","title":"Actors.Actor.Entity.Lifecycle.deactivate/1","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#init/1","title":"Actors.Actor.Entity.Lifecycle.init/1","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#load_state/1","title":"Actors.Actor.Entity.Lifecycle.load_state/1","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#snapshot/1","title":"Actors.Actor.Entity.Lifecycle.snapshot/1","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Lifecycle.html#terminate/2","title":"Actors.Actor.Entity.Lifecycle.terminate/2","type":"function"},{"doc":"`Entity.Supervisor` is the Supervisor of all Host Actors in the system.\nThis in turn is Partitioned using a PartitionSupervisor.\nWe use a hash function based on each Actor's child_spec to partition the actors\nso that the entire Supervisor is not overloaded and\nlessening the possibility of cascading failures.","ref":"Actors.Actor.Entity.Supervisor.html","title":"Actors.Actor.Entity.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Actors.Actor.Entity.Supervisor.html#child_spec/1","title":"Actors.Actor.Entity.Supervisor.child_spec/1","type":"function"},{"doc":"Adds a Actor to the dynamic supervisor.","ref":"Actors.Actor.Entity.Supervisor.html#lookup_or_create_actor/3","title":"Actors.Actor.Entity.Supervisor.lookup_or_create_actor/3","type":"function"},{"doc":"","ref":"Actors.Actor.Entity.Supervisor.html#start_link/1","title":"Actors.Actor.Entity.Supervisor.start_link/1","type":"function"},{"doc":"`Invoker` is responsible for making calls to the Host Function","ref":"Actors.Actor.Interface.html","title":"Actors.Actor.Interface","type":"behaviour"},{"doc":"","ref":"Actors.Actor.Interface.html#c:invoke_host/3","title":"Actors.Actor.Interface.invoke_host/3","type":"callback"},{"doc":"","ref":"Actors.Actor.Interface.html#t:default_methods/0","title":"Actors.Actor.Interface.default_methods/0","type":"type"},{"doc":"","ref":"Actors.Actor.Interface.html#t:payload/0","title":"Actors.Actor.Interface.payload/0","type":"type"},{"doc":"","ref":"Actors.Actor.Interface.html#t:state/0","title":"Actors.Actor.Interface.state/0","type":"type"},{"doc":"`Http` is responsible for the communication between the Proxy and the Host application\nwhen using the HTTP protocol.","ref":"Actors.Actor.Interface.Http.html","title":"Actors.Actor.Interface.Http","type":"module"},{"doc":"`InvocationScheduler` is a global process for the cluster that controls\nall Actions of type Schedule.\nThis process is global to allow that even after restarts of a process or restart\nof an application we will still be able to perform invocations to actors,\nwithout the need for persistent storage such as a database.","ref":"Actors.Actor.InvocationScheduler.html","title":"Actors.Actor.InvocationScheduler","type":"module"},{"doc":"","ref":"Actors.Actor.InvocationScheduler.html#child_spec/0","title":"Actors.Actor.InvocationScheduler.child_spec/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Actors.Actor.InvocationScheduler.html#child_spec/1","title":"Actors.Actor.InvocationScheduler.child_spec/1","type":"function"},{"doc":"","ref":"Actors.Actor.InvocationScheduler.html#next_hibernate_delay/0","title":"Actors.Actor.InvocationScheduler.next_hibernate_delay/0","type":"function"},{"doc":"","ref":"Actors.Actor.InvocationScheduler.html#schedule_invoke/1","title":"Actors.Actor.InvocationScheduler.schedule_invoke/1","type":"function"},{"doc":"","ref":"Actors.Actor.InvocationScheduler.html#start_link/0","title":"Actors.Actor.InvocationScheduler.start_link/0","type":"function"},{"doc":"This module provides functions for creating actor host pools for pooled actors.","ref":"Actors.Actor.Pool.html","title":"Actors.Actor.Pool","type":"module"},{"doc":"Creates an actor host pool for a given pooled actor.","ref":"Actors.Actor.Pool.html#create_actor_host_pool/2","title":"Actors.Actor.Pool.create_actor_host_pool/2","type":"function"},{"doc":"- `actor`: The actor for which the host pool should be created.\n- `opts`: Additional options for the host pool.","ref":"Actors.Actor.Pool.html#create_actor_host_pool/2-parameters","title":"Parameters - Actors.Actor.Pool.create_actor_host_pool/2","type":"function"},{"doc":"Returns a list of `HostActor` structs representing the hosts in the pool.","ref":"Actors.Actor.Pool.html#create_actor_host_pool/2-returns","title":"Returns - Actors.Actor.Pool.create_actor_host_pool/2","type":"function"},{"doc":"`StateManager` Implements behavior that allows an Actor's state to be saved\nto persistent storage using database drivers.","ref":"Actors.Actor.StateManager.html","title":"Actors.Actor.StateManager","type":"module"},{"doc":"","ref":"Actors.Actor.StateManager.html#is_new?/2","title":"Actors.Actor.StateManager.is_new?/2","type":"function"},{"doc":"","ref":"Actors.Actor.StateManager.html#load/1","title":"Actors.Actor.StateManager.load/1","type":"function"},{"doc":"","ref":"Actors.Actor.StateManager.html#save/3","title":"Actors.Actor.StateManager.save/3","type":"function"},{"doc":"","ref":"Actors.Actor.StateManager.html#save_async/3","title":"Actors.Actor.StateManager.save_async/3","type":"function"},{"doc":"`StateManager.Behaviour` Defines behavior that allows an Actor's state\nto be saved to persistent storage using database drivers.","ref":"Actors.Actor.StateManager.Behaviour.html","title":"Actors.Actor.StateManager.Behaviour","type":"behaviour"},{"doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:is_new?/2","title":"Actors.Actor.StateManager.Behaviour.is_new?/2","type":"callback"},{"doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:load/1","title":"Actors.Actor.StateManager.Behaviour.load/1","type":"callback"},{"doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:save/3","title":"Actors.Actor.StateManager.Behaviour.save/3","type":"callback"},{"doc":"","ref":"Actors.Actor.StateManager.Behaviour.html#c:save_async/3","title":"Actors.Actor.StateManager.Behaviour.save_async/3","type":"callback"},{"doc":"`Config` defines methods that allow recovery of system settings","ref":"Actors.Config.html","title":"Actors.Config","type":"behaviour"},{"doc":"","ref":"Actors.Config.html#c:get/2","title":"Actors.Config.get/2","type":"callback"},{"doc":"","ref":"Actors.Config.html#c:load/1","title":"Actors.Config.load/1","type":"callback"},{"doc":"`Config.Vapor` Implements the `Config` behavior\nto allow the retrieval of system variables\nthat will be included in the system configuration.","ref":"Actors.Config.Vapor.html","title":"Actors.Config.Vapor","type":"module"},{"doc":"Initializes the %K8s.Conn{} struct depending on the mix environment.","ref":"Actors.K8s.K8sConn.html","title":"Actors.K8s.K8sConn","type":"module"},{"doc":"","ref":"Actors.K8s.K8sConn.html#get/1","title":"Actors.K8s.K8sConn.get/1","type":"function"},{"doc":"","ref":"Actors.K8s.K8sConn.html#get!/1","title":"Actors.K8s.K8sConn.get!/1","type":"function"},{"doc":"`Node.Client` Uses the HTTP interface to communicate with the application\nthat owns the ActorHosts.","ref":"Actors.Node.Client.html","title":"Actors.Node.Client","type":"module"},{"doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#delete/3","title":"Actors.Node.Client.delete/3","type":"function"},{"doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#delete!/3","title":"Actors.Node.Client.delete!/3","type":"function"},{"doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#get/3","title":"Actors.Node.Client.get/3","type":"function"},{"doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#get!/3","title":"Actors.Node.Client.get!/3","type":"function"},{"doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#head/3","title":"Actors.Node.Client.head/3","type":"function"},{"doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#head!/3","title":"Actors.Node.Client.head!/3","type":"function"},{"doc":"","ref":"Actors.Node.Client.html#invoke_host_actor/2","title":"Actors.Node.Client.invoke_host_actor/2","type":"function"},{"doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#options/3","title":"Actors.Node.Client.options/3","type":"function"},{"doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#options!/3","title":"Actors.Node.Client.options!/3","type":"function"},{"doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Actors.Node.Client.html#patch/4","title":"Actors.Node.Client.patch/4","type":"function"},{"doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Actors.Node.Client.html#patch!/4","title":"Actors.Node.Client.patch!/4","type":"function"},{"doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Actors.Node.Client.html#post/4","title":"Actors.Node.Client.post/4","type":"function"},{"doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Actors.Node.Client.html#post!/4","title":"Actors.Node.Client.post!/4","type":"function"},{"doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Actors.Node.Client.html#put/4","title":"Actors.Node.Client.put/4","type":"function"},{"doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"Actors.Node.Client.html#put!/4","title":"Actors.Node.Client.put!/4","type":"function"},{"doc":"Perform a request.","ref":"Actors.Node.Client.html#request/2","title":"Actors.Node.Client.request/2","type":"function"},{"doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"Actors.Node.Client.html#request/2-options","title":"Options - Actors.Node.Client.request/2","type":"function"},{"doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"Actors.Node.Client.html#request/2-examples","title":"Examples - Actors.Node.Client.request/2","type":"function"},{"doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"Actors.Node.Client.html#request!/2","title":"Actors.Node.Client.request!/2","type":"function"},{"doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#trace/3","title":"Actors.Node.Client.trace/3","type":"function"},{"doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"Actors.Node.Client.html#trace!/3","title":"Actors.Node.Client.trace!/3","type":"function"},{"doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"Actors.Node.Client.html#t:option/0","title":"Actors.Node.Client.option/0","type":"type"},{"doc":"The `ActorRegistry` module provides a registry for actor entities.\n\nIt allows for registering and looking up actors and also provides\nmethods for adding and removing invocation requests for actors.","ref":"Actors.Registry.ActorRegistry.html","title":"Actors.Registry.ActorRegistry","type":"module"},{"doc":"Get all invocations stored for actor","ref":"Actors.Registry.ActorRegistry.html#get_all_invocations/0","title":"Actors.Registry.ActorRegistry.get_all_invocations/0","type":"function"},{"doc":"iex> ActorRegistry.get_all_invocations()\n    [ >]","ref":"Actors.Registry.ActorRegistry.html#get_all_invocations/0-examples","title":"Examples - Actors.Registry.ActorRegistry.get_all_invocations/0","type":"function"},{"doc":"","ref":"Actors.Registry.ActorRegistry.html#get_hosts_by_actor/2","title":"Actors.Registry.ActorRegistry.get_hosts_by_actor/2","type":"function"},{"doc":"Fetch current entities of the service.\nReturns `HostActor` with Host and specific actor.","ref":"Actors.Registry.ActorRegistry.html#lookup/2","title":"Actors.Registry.ActorRegistry.lookup/2","type":"function"},{"doc":"Register `member` entities to the ActorRegistry.\nReturns `Cluster` with all Host members.","ref":"Actors.Registry.ActorRegistry.html#register/1","title":"Actors.Registry.ActorRegistry.register/1","type":"function"},{"doc":"iex> hosts = [%HostActor{node: Node.self(), actor: actor, opts: []}}]\n    iex> ActorRegistry.register(hosts)\n    :ok","ref":"Actors.Registry.ActorRegistry.html#register/1-examples","title":"Examples - Actors.Registry.ActorRegistry.register/1","type":"function"},{"doc":"Registers a invocation request in CRDT Database\nUsually used for invocation schedulings","ref":"Actors.Registry.ActorRegistry.html#register_invocation_request/2","title":"Actors.Registry.ActorRegistry.register_invocation_request/2","type":"function"},{"doc":"Removes a invocation request in CRDT Database\nUsually used for invocation schedulings","ref":"Actors.Registry.ActorRegistry.html#remove_invocation_request/2","title":"Actors.Registry.ActorRegistry.remove_invocation_request/2","type":"function"},{"doc":"`HostActor` Defines the type of Actor that will be registered in `ActorRegistry`.","ref":"Actors.Registry.HostActor.html","title":"Actors.Registry.HostActor","type":"module"},{"doc":"","ref":"Actors.Registry.HostActor.html#t:t/0","title":"Actors.Registry.HostActor.t/0","type":"type"},{"doc":"`Random` implements the `Actors.Registry.LoadBalance.Strategy` behavior\nby searching the actors randomly, that is,\nif you have registered the same actor in N nodes and try to invoke it,\nthe Registry can, if configured,\nuse the random strategy to locate one of them in any of the nodes in a random way,\nas the name suggests.","ref":"Actors.Registry.LoadBalance.Strategies.Random.html","title":"Actors.Registry.LoadBalance.Strategies.Random","type":"module"},{"doc":"`RoundRobin` implements the `Actors.Registry.LoadBalance.Strategy` behavior\nby searching the actors using a RoundRobin strategy,\nthat is, it will try to distribute the load equally among the nodes.","ref":"Actors.Registry.LoadBalance.Strategies.RoundRobin.html","title":"Actors.Registry.LoadBalance.Strategies.RoundRobin","type":"module"},{"doc":"`LoadBalance.Strategy` Define an interface to allow the search of actors\nin the Distributed Registry.","ref":"Actors.Registry.LoadBalance.Strategy.html","title":"Actors.Registry.LoadBalance.Strategy","type":"behaviour"},{"doc":"","ref":"Actors.Registry.LoadBalance.Strategy.html#c:next_host/2","title":"Actors.Registry.LoadBalance.Strategy.next_host/2","type":"callback"},{"doc":"","ref":"Actors.Registry.LoadBalance.Strategy.html#t:hosts/0","title":"Actors.Registry.LoadBalance.Strategy.hosts/0","type":"type"},{"doc":"","ref":"Actors.Registry.LoadBalance.Strategy.html#t:opts/0","title":"Actors.Registry.LoadBalance.Strategy.opts/0","type":"type"},{"doc":"`LoadBalance` to call hosts","ref":"Actors.Registry.LoadBalancer.html","title":"Actors.Registry.LoadBalancer","type":"module"},{"doc":"","ref":"Actors.Registry.LoadBalancer.html#next_host/1","title":"Actors.Registry.LoadBalancer.next_host/1","type":"function"},{"doc":"`Acl` is a acces control list helper module","ref":"Actors.Security.Acl.html","title":"Actors.Security.Acl","type":"behaviour"},{"doc":"","ref":"Actors.Security.Acl.html#c:get_policies!/0","title":"Actors.Security.Acl.get_policies!/0","type":"callback"},{"doc":"","ref":"Actors.Security.Acl.html#c:is_authorized?/2","title":"Actors.Security.Acl.is_authorized?/2","type":"callback"},{"doc":"","ref":"Actors.Security.Acl.html#c:load_acl_policies/1","title":"Actors.Security.Acl.load_acl_policies/1","type":"callback"},{"doc":"","ref":"Actors.Security.Acl.html#t:base_policies_path/0","title":"Actors.Security.Acl.base_policies_path/0","type":"type"},{"doc":"","ref":"Actors.Security.Acl.html#t:invocation/0","title":"Actors.Security.Acl.invocation/0","type":"type"},{"doc":"","ref":"Actors.Security.Acl.html#t:policies/0","title":"Actors.Security.Acl.policies/0","type":"type"},{"doc":"","ref":"Actors.Security.Acl.DefaultAclManager.html","title":"Actors.Security.Acl.DefaultAclManager","type":"module"},{"doc":"`DefaultAclManager`","ref":"Actors.Security.Acl.DefaultAclManager.html#load_acl_policies/1","title":"Actors.Security.Acl.DefaultAclManager.load_acl_policies/1","type":"function"},{"doc":"","ref":"Actors.Security.Acl.Policy.html","title":"Actors.Security.Acl.Policy","type":"module"},{"doc":"","ref":"Actors.Security.Acl.Policy.html#t:t/0","title":"Actors.Security.Acl.Policy.t/0","type":"type"},{"doc":"`AclEvaluator`is responsible for evaluating whether a request can be accepted\nor not based on the informed Access Control List policy.","ref":"Actors.Security.Acl.Rules.AclEvaluator.html","title":"Actors.Security.Acl.Rules.AclEvaluator","type":"module"},{"doc":"Applies a policy on a request by evaluating whether the request should pass or not.","ref":"Actors.Security.Acl.Rules.AclEvaluator.html#eval/3","title":"Actors.Security.Acl.Rules.AclEvaluator.eval/3","type":"function"},{"doc":"iex> Actors.Security.Acl.Rules.AclEvaluator.eval(\n    ...> %Actors.Security.Acl.Policy{\n    ...>   name: \"the-police\",\n    ...>   type: :allow,\n    ...>   actors: [\"*\"],\n    ...>   actions: [\"get\"],\n    ...>   actor_systems: [\"*\"]\n    ...> },\n    ...> %Eigr.Functions.Protocol.InvocationRequest{\n    ...>    actor: %Eigr.Functions.Protocol.Actors.Actor{id: %Eigr.Functions.Protocol.Actors.ActorId{name: \"joe\"}},\n    ...>    action_name: \"get\",\n    ...>    caller: %Eigr.Functions.Protocol.Actors.ActorId{name: \"robert\", system: \"actor-system\"}\n    ...> }\n    ...> )\n    true","ref":"Actors.Security.Acl.Rules.AclEvaluator.html#eval/3-example","title":"Example - Actors.Security.Acl.Rules.AclEvaluator.eval/3","type":"function"},{"doc":"This module must be used by initializing the container via initContainers\n\n```\ninitContainers:\n  - args:\n      - eval\n      - Kompost.Webhooks.bootstrap_tls(:prod, \"tls-certs\")\n    image: docker.io/eigr/spawn-proxy:1.0.0-rc16\n    name: init-certificates\nserviceAccountName: kompost\nvolumes:\n  - name: certs\n    secret:\n      optional: true\n      secretName: tls-certs\n```","ref":"Actors.Security.Tls.Initializer.html","title":"Actors.Security.Tls.Initializer","type":"module"},{"doc":"","ref":"Actors.Security.Tls.Initializer.html#bootstrap_tls/5","title":"Actors.Security.Tls.Initializer.bootstrap_tls/5","type":"function"},{"doc":"","ref":"Actors.SplitBrainDetector.html","title":"Actors.SplitBrainDetector","type":"behaviour"},{"doc":"","ref":"Actors.SplitBrainDetector.html#c:check_network_partition/2","title":"Actors.SplitBrainDetector.check_network_partition/2","type":"callback"},{"doc":"","ref":"Actors.SplitBrainDetector.html#c:check_network_partition!/2","title":"Actors.SplitBrainDetector.check_network_partition!/2","type":"callback"},{"doc":"","ref":"Actors.SplitBrainDetector.html#t:node_id/0","title":"Actors.SplitBrainDetector.node_id/0","type":"type"},{"doc":"","ref":"Actors.SplitBrainDetector.html#t:status/0","title":"Actors.SplitBrainDetector.status/0","type":"type"},{"doc":"Documentation for `Sidecar`.","ref":"Sidecar.html","title":"Sidecar","type":"module"},{"doc":"This module was copied and adapted from this project https://github.com/straw-hat-team/beam-monorepo\n\nCatches `SIGTERM` signal to gracefully stop the system.\nBy default, a `SIGTERM` signal triggers a `System.stop/0`. When running in a Kubernetes-managed cluster or an\ninfrastructure alike, the nodes will be joining and leaving the cluster when auto-scaling is enabled or when deploying\nnew version of the application.\nYou should let the system to gracefully stop in combination with readiness probe you can make sure that the system is\nready to stop without a relying on a `SIGKILL` signal.\n\nYou can read more about this at [Termination of Pods](https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#pod-termination).\nWhen a `SIGTERM` is received, the handler enters \"connection draining mode\", during which `get_status/0` starts\nreturning `:draining` status, and then, after a delay, the handler calls `System.stop/1`, carefully halting the Erlang VM\nand starts returning `:stopping` status.","ref":"Sidecar.GracefulShutdown.html","title":"Sidecar.GracefulShutdown","type":"module"},{"doc":"Returns a specification to start `Sidecar.GracefulShutdown` under a supervisor.\nSee the \"Child specification\" section in the Supervisor module for more detailed information.","ref":"Sidecar.GracefulShutdown.html#child_spec/1","title":"Sidecar.GracefulShutdown.child_spec/1","type":"function"},{"doc":"Returns the status of the system.","ref":"Sidecar.GracefulShutdown.html#get_status/0","title":"Sidecar.GracefulShutdown.get_status/0","type":"function"},{"doc":"Returns true if the system is in the `:running` status.","ref":"Sidecar.GracefulShutdown.html#running?/0","title":"Sidecar.GracefulShutdown.running?/0","type":"function"},{"doc":"Configuration options for the server.\n- `shutdown_delay_ms`: milliseconds before draining the VM after `SIGTERM`. milliseconds between start of connection draining\n    and ordered shut-down using `System.stop/0`.\n- `notify_pid`: process ID to notify when the server started draining.\n- `init_stop?`: whether to call `:System.stop/1` when a `SIGTERM` is received. Useful for testing since we don't want\n    to stop the VM when testing. **Be careful when using this option since it should always be `true` in production.**","ref":"Sidecar.GracefulShutdown.html#t:opts/0","title":"Sidecar.GracefulShutdown.opts/0","type":"type"},{"doc":"The state of system.\n- `:draining` - the node is draining and will be shutdown after the delay.\n- `:stopping` - the node is shutting down.\n- `:running` - the node is accepting work.","ref":"Sidecar.GracefulShutdown.html#t:status/0","title":"Sidecar.GracefulShutdown.status/0","type":"type"},{"doc":"**Actor Mesh Serverless Platform**\n\n![ci](https://github.com/eigr/spawn/actions/workflows/ci.yaml/badge.svg) ![release](https://github.com/eigr/spawn/actions/workflows/release.yaml/badge.svg) ![last commit](https://img.shields.io/github/last-commit/eigr/spawn?style=social) [![join discord](https://badgen.net/badge/discord/Join%20Eigr%20on%20Discord/discord?icon=discord&label&color=blue)](https://discord.gg/2PcshvfS93) [![twitter](https://badgen.net/badge/twitter/Follow%20Eigr%20on%20Twitter/discord?icon=twitter&label&color=blue)](https://discord.gg/2PcshvfS93)\n\n### **[Website](https://eigr.io)** • **[Getting Started](#getting-started)** • **[SDKs](#sdks)** • **[Documentation](https://eigr.io/docs/projects-spawn/spawn-introduction/)** • **[Blog](https://eigr.io/blog/)**","ref":"Spawn.html","title":"Spawn","type":"module"},{"doc":"**_What is Spawn?_**\n\nThere are two ways to answer this question, the short form would be something like:\n\n> \"Spawn is an Actor Model framework and Serverless Platform, which does a lot, really lot, of cool stuff that allows you to quickly deliver software oriented to your business domain.\"\n\nWell since this answer doesn't say much, let's go the long way.\n\nSpawn's main goal is to remove the complexity in developing microservices, providing simple and intuitive APIs, as well as a declarative deployment and configuration model and based on a Serverless architecture and Actor Model.\nThis leaves the developer to focus on developing the business domain while the platform deals with the complexities and infrastructure needed to support the scalable, resilient, distributed, and event-driven architecture that microservices-driven systems requires.\n\nSpawn is based on the sidecar proxy pattern to provide a polyglot Actor Model framework and platform.\nSpawn's technology stack, built on the [BEAM VM](https://www.erlang.org/blog/a-brief-beam-primer/) (Erlang's virtual machine) and [OTP](https://www.erlang.org/doc/design_principles/des_princ.html), provides support for different languages from its native Actor model.\n\nSpawn is made up of the following components:\n\n- A semantic protocol based on Protocol Buffers\n- A Sidecar Proxy, written in Elixir, that implements this protocol and persistent storage\n  adapters.\n- Support libraries in different programming languages.\n\nThese are the main concepts:\n\n1. **A Stateful Serverless Platform** running on top of Kubernetes, based on the Sidecar pattern and built on top of the BEAM VM.\n\n2. **Inversion of State**. This means that unlike conventional Serverless architectures where the developer fetches state from persistent storage we on the other hand send the state as the context of the event the function is receiving. Bringing state closer to computing.\n\n3. **Polyglot**. The platform must embrace as many software communities as possible. That's why the polyglot language model is adopted with SDK development for various programming languages.\n\n4. **Less Infrastructure**. This means that our platform will give the developer the tools to focus only on their business without worrying about issues such as:\n\n   - Resource allocation\n   - Definition of connections and Pools\n   - Service discovery\n   - Source/Sink of Events\n   - Other infrastructure issues\n\n5. **The basic primitive is the Actor** (from the actors model) and **_not_** the Function (from the traditional serverless architectures).\n\n6. Horizontal scalability with automatic **Activation** and **Deactivation** of Actors on demand.\n\nWatch the video explaining how it works:\n\n[![asciicast](https://asciinema.org/a/V2zUGsRmOjs0kI7swVTsKg7BQ.svg)](https://asciinema.org/a/V2zUGsRmOjs0kI7swVTsKg7BQ)\n\n> **_NOTE:_** This video was recorded with an old version of the SDK for Java. That's why errors are seen in Deployment","ref":"Spawn.html#module-overview","title":"Overview - Spawn","type":"module"},{"doc":"The advancement of Cloud Computing, Edge computing, Containers, Orchestrators, Data-\nOriented Services, and global-scale products aimed at serving audiences in various regions of\nour world make the development of software today a task of enormous complexity. It is not\nuncommon to see dozens, if not hundreds, of non-functional requirements that must be met\nto build a system. All this complexity falls on the developer, who often does not have all the\nknowledge or time to create such systems satisfactorily.\n\nWhen studying this scenario, we realize that many of these current problems belong to the following groups:\n\n- Fast business oriented software delivery.\n- State management.\n- Scalability.\n- Resilience and fault tolerance.\n- Distributed and/or regionally distributed computing.\n- Integration Services.\n- Polyglot services.\n\nThe actor model on which Spawn is based can solve almost all the problems on this list, with\nScalability, resilience, fault tolerance, and state management by far the top success stories of\ndifferent known actor model implementations. So what we needed to do was add Integration\n\nServices, fast, business-oriented delivery, distributed computing, and polyglot services to the\nrecipe so we could revolutionize software development as we know it today.\n\nThat's precisely what we did with our platform called Eigr Functions Spawn.\n\nSpawn takes care of the entire infrastructure layer by abstracting all the complex issues that\nare not part of the business domain it is intended to address.\n\nParticularly domains such as game development, machine learning pipelines, complex event\nprocessing, real-time data ingestion, service integrations, financial or transactional services,\nand logistics are some of the domains that can be mastered by the Eigr Functions Spawn\nplatform.","ref":"Spawn.html#module-what-problem-spawn-solves","title":"What problem Spawn solves - Spawn","type":"module"},{"doc":"Spawn takes the Actor Model's distribution, fault tolerance, and high concurrent capability in\nits most famous implementation, the BEAM Erlang VM implementation, and adds to the\nflexibility and dynamism that the sidecar pattern offers to build cross-platform and polyglot\nmicroservice-oriented architectures.\n\nTo achieve these goals, the Eigr Functions Spawn architecture is composed of the following components:\n\n![image info](docs/diagrams/spawn-architecture.jpg)\n\nAs seen above, the Eigr Functions Spawn platform architecture is separated into different components, each with its responsibility. We will detail the components below.\n\n- **k8s Operator:** Responsible for interacting with the Kubernetes API and coordinating the deployments of the other components. The user interacts with it using our specific CRDs ([Custom Resource Definitions](https://kubernetes.io/docs/concepts/extend-kubernetes/api-extension/custom-resources/)). We'll talk more about our CRDs later.\n\n- **Cloud Storage:** Despite not being directly part of the platform, it is worth mentioning here that Spawn uses user-defined persistent storage to store the state of its Actors. Different types of persistent storage can be used, such as relational databases such as MySQL, Postgres, among others. In the future, we will support other types of databases, both relational and non-relational.\n\n- **Activators:** Activators are applications responsible for ingesting data from external sources for certain user-defined actors and are configured through their own CRD. They are responsible for listening to a user-configured event and forward this event through a direct invocation to a specific target actor. Different types of Activators exist to consume events from other providers such as Google PubSub, RabbitMQ, Amazon SQS, etc.\n\n- **Actor Host Function:** The container where the user defines his actors and all the business logic of his actors around the state of these actors through a specific SDK for each supported programming language.\n\n- **Spawn Sidecar Proxy:** The centerpiece of the gear is our sidecar proxy; in turn it is responsible for managing the entire lifecycle of user-defined actors through our SDKs and also responsible for managing the state of these actors in persistent storage. The Spawn proxy can also allow the user to develop different integration flows between its actors such as Forwards,\n  Effects, Pipes, and in the future, other essential standards such as Saga, Aggregators, Scatter-\n  Gather, external invocations, and others.\n  Our proxy connects directly and transparently to all cluster members without needing for a single point of failure, i.e., a true mesh network.\n\nAs we use Kubernetes to orchestrate our workloads through our Operator each user application will be summarized at the end there is a POD which is the smallest measure of workload present in kubernetes. Below is an image of how the components are grouped inside a POD in Kubernetes:\n\n![image info](docs/diagrams/spawn-pod-internals.jpg)\n\nIn turn, each Sidecar container within a POD organizes itself to form an Erlang cluster for each ActorSystem. Different ActorSystems can coexist in the same Kubernetes cluster and these in turn communicate cross ActorSystem using a Nats Broker as a transport mechanism via message passing. In this way we can granulate a large system into smaller parts, forming small Erlang clusters that still manage to maintain the behavior of a larger cluster depending on how the developer organizes its deployable units.","ref":"Spawn.html#module-spawn-architecture","title":"Spawn Architecture - Spawn","type":"module"},{"doc":"- [x] Distribution. Automatic and transparent cluster formation via Kubernetes Operator.\n  - [x] Erlang Distributed as transport.\n    - [x] mTLS Support with Erlang Dist.\n    - [x] Automatic renewal of certificates.\n  - [x] Cross ActorSystem invocation Nats distribution.\n- [x] Configuration management via Kubernetes [CRDs](https://kubernetes.io/docs/tasks/extend-kubernetes/custom-resources/custom-resource-definitions/) and Envinronment Variables.\n- [x] Statestores. Adapters for persistent storage using multiple database providers.\n  - [x] Sqlite\n  - [x] MySql\n  - [x] Postgres\n  - [x] CockroachDB\n  - [x] MSSQL\n  - [ ] Native via Mnesia\n- [x] Automatic activation and deactivation of Actors.\n- [x] Horizontal Scalability\n  - [x] automatically controlled by the Operator using Kubernetes HPA based on memory and cpu.\n  - [ ] automatically controlled by the Operator via Internal Metrics.\n  - [ ] automatically controlled by the Operator via Custom Metrics.\n- [x] Workflows\n  - [x] Broadcast. Communicates with other actors through pubsub channel semantics.\n    - [x] In Memory broadcast. Using [Phoenix.PubSub](https://github.com/phoenixframework/phoenix_pubsub) as transport.\n    - [x] Nats broadcast. Using [Nats](https://nats.io/) as transport.\n  - [x] External Broadcast. Sends events with pubsub semantics outside the actor system using the same transport types as Broadcast.\n  - [x] Forwards. Forwards the input parameter of an action of an actor as input to another action of another actor.\n  - [x] Pipes. Forwards the output type of an action of one actor to the input of an action of another actor. Like Unix pipes.\n  - [x] Side effects. Sends an effect as a result of your computation for other Actors to handle.\n  - [ ] Saga.\n- [x] SDKs\n  - [x] Elixir. All features implemented.\n  - [x] Node/Typescript. All features implemented.\n  - [x] Java. Partially implemented.\n  - [ ] Python. Under development.\n  - [ ] Go. Under development.\n  - [ ] Rust. Under development.\n  - [ ] .Net/C#. Under development.\n- [x] Activators\n  - [x] CronJob Scheduler.\n  - [x] gRPC/HTTP.\n    - [x] Unary. Under development.\n    - [ ] Stream In.\n    - [ ] Stream Out.\n    - [ ] Bid Streamed.\n  - [x] RabbitMQ.\n  - [ ] Kafka.\n  - [ ] Amazon SQS.\n  - [ ] Google PubSub.\n- [x] Observability\n  - [x] OTLP Tracing.\n  - [x] Prometheus Metrics.\n- [x] Secucrity\n  - [x] Database encryption with AES-ACM-V1.\n  - [ ] Actor ACL (Access Control List). Under development.\n  - [ ] Actor invocation with Authentication/Authorization Basic Auth flow. Under development.\n  - [ ] Actor invocation with Authentication/Authorization JWT Auth flow. Under development.","ref":"Spawn.html#module-features","title":"Features - Spawn","type":"module"},{"doc":"The recommended way to install Spawn is via our Kubernetes Operator.\n\n#","ref":"Spawn.html#module-install","title":"Install - Spawn","type":"module"},{"doc":"- Kubernetes Cluster\n- Nats broker accessible within the cluster (See the note below).\n\n> **_Important:_** Nats broker is only necessary if you want to use the Activators feature or if you need your actors to communicate between different ActorSystems.\n\n#","ref":"Spawn.html#module-prerequisites","title":"Prerequisites - Spawn","type":"module"},{"doc":"To install you need to download the Operator manifest file. The following command shows how this could be done directly via the command line:\n\n```shell\nkubectl create ns eigr-functions && curl -L https://github.com/eigr/spawn/releases/download/{release-version}/manifest.yaml | kubectl apply -f -\n```\n\n> **_NOTE:_** You need to inform the desired release version. For example:\n\n```shell\nkubectl create ns eigr-functions && curl -L https://github.com/eigr/spawn/releases/download/v1.0.0-rc16/manifest.yaml | kubectl apply -f -\n```","ref":"Spawn.html#module-instructions","title":"Instructions - Spawn","type":"module"},{"doc":"First we must develop our HostFunction. Look for the documentation for [each SDK](#sdks) to know how to proceed but below are some examples:\n\n- [Using Elixir SDK](./spawn_sdk/spawn_sdk#installation)\n- [Using Java SDK](https://github.com/eigr/spawn-springboot-sdk/blob/main/README.md#installation)\n- [Using NodeJS SDK](https://github.com/eigr/spawn-node-sdk#installation)\n\nHaving our container created and containing our Actor Host Function (following above SDK recommendations), we must deploy\nit in a Kubernetes cluster with the Spawn Controller installed (See more about this\nprocess in the section on installation).\n\nIn this tutorial we are going to use a MySql database. In this case, in order for Spawn to know how to connect to the database instance, it is first necessary to create a kubernetes secret in same namespace you installed the Spawn Operator with the connection data and other parameters. Example:\n\n```shell\nkubectl create secret generic mysql-connection-secret -n eigr-functions \\\n  --from-literal=database=eigr-functions-db \\\n  --from-literal=host='mysql' \\\n  --from-literal=port='3306' \\\n  --from-literal=username='admin' \\\n  --from-literal=password='admin' \\\n  --from-literal=encryptionKey=$(openssl rand -base64 32)\n```\n\nSapwn securely encrypts the Actors' State, so the **_encryptionKey_** item must be informed and must be a key of reasonable size and complexity to ensure the security of your data.\n\n> **_NOTE:_** To learn more about Statestores settings, see the [statestore section](#statestores).\n\nIf you are going to use the Activators resource in your project or if you want your Actors to be able to communicate between different ActorSystems then you will need to create a secret with the connection information with the Nats server. See an example of how to do this below:\n\n> **_NOTICE:_** It is not within the scope of this tutorial to install Nats but a simple way to do it in kubernetes is in to run these commands: **helm repo add nats https://nats-io.github.io/k8s/helm/charts/ && helm install spawn-nats nats/nats**.\n\nNow create the config file with the Nats credentials:\n\n```\nkubectl -n default create secret generic nats-invocation-conn-secret \\\n  --from-literal=url=\"nats://spawn-nats:4222\" \\\n  --from-literal=authEnabled=\"false\" \\\n  --from-literal=tlsEnabled=\"false\" \\\n  --from-literal=username=\"\" \\\n  --from-literal=password=\"\"\n```\n\nNow in a directory of your choice, create a file called **_system.yaml_** with the following content:\n\n```yaml\n---\napiVersion: spawn-eigr.io/v1\nkind: ActorSystem\nmetadata:\n  name: spawn-system # Mandatory. Name of the ActorSystem\n  namespace: default # Optional. Default namespace is \"default\"\nspec:\n  # This externalInvocation section is necessary only if Nats broker is used in your project.\n  externalInvocation:\n    enabled: \"true\"\n    externalConnectorRef: nats-invocation-conn-secret\n  statestore:\n    type: MySql # Valid are [MySql, Postgres, Sqlite, MSSQL, CockroachDB]\n    credentialsSecretRef: mysql-connection-secret # The secret containing connection params created in the previous step.\n    pool: # Optional\n      size: \"10\"\n```\n\nThis file will be responsible for creating a system of actors in the cluster.\n\nNow create a new file called **_host.yaml_** with the following content:\n\n```yaml\n---\napiVersion: spawn-eigr.io/v1\nkind: ActorHost\nmetadata:\n  name: spawn-springboot-example # Mandatory. Name of the Node containing Actor Host Functions\n  namespace: default # Optional. Default namespace is \"default\"\n  annotations:\n    # Mandatory. Name of the ActorSystem declared in ActorSystem CRD\n    spawn-eigr.io/actor-system: spawn-system\nspec:\n  host:\n    image: eigr/spawn-springboot-examples:latest # Mandatory\n    ports:\n      - name: \"http\"\n        containerPort: 8091\n```\n\nThis file will be responsible for deploying your host function and actors in the cluster.\nBut if you are using the SDK for Elixir then your Yaml should look like this:\n\n```yaml\n---\napiVersion: spawn-eigr.io/v1\nkind: ActorHost\nmetadata:\n  name: spawn-dice-game\n  namespace: default\n    spawn-eigr.io/actor-system: spawn-system\nspec:\n  host:\n    embedded: true # This indicates that it is a native BEAM application and therefore does not need a sidecar proxy attached.\n    image: eigr/dice-game-example:0.5.3\n    ports:\n      - name: \"http\"\n        containerPort: 8800\n```\n\nNow that the files have been defined, we can apply them to the cluster:\n\n```shell\nkubectl apply -f system.yaml\nkubectl apply -f host.yaml\n```\n\nAfter that, just check your actors with:\n\n```shell\nkubectl get actorhosts\n```\n\n#","ref":"Spawn.html#module-getting-started","title":"Getting Started - Spawn","type":"module"},{"doc":"You can find some examples of using Spawn in the links below:\n\n- **Hatch**: https://github.com/zblanco/hatch\n- **Elixir Dice Game. Spawn with Phoenix app**: https://github.com/eigr-labs/spawn_game_example.git\n- **Distributed Image Processing**: https://github.com/eigr-labs/spawn-distributed-image-processing\n- **Federated Data Example**: https://github.com/eigr-labs/spawn-federated-data-example\n- **Fleet**: https://github.com/sleipnir/fleet-spawn-example\n- **Spawn Polyglot Example**: https://github.com/sleipnir/spawn-polyglot-ping-pong\n\n#","ref":"Spawn.html#module-examples","title":"Examples - Spawn","type":"module"},{"doc":"You can see some talks on Youtube about Eigr Community or Spawn in the links below:\n\n- **Marcel Lanz on Code Beam Europe 2022**: https://youtu.be/jgR7Oc_GXAg\n- **Adriano Santos on Code Beam BR 2022**: Link not yet released by the event organizers","ref":"Spawn.html#module-talks","title":"Talks - Spawn","type":"module"},{"doc":"Another important part of Spawn is the SDKs implemented in different languages that aim to\nabstract all the protocol specifics and expose an easy and intuitive API to developers.\n\n| SDK                                                                   | Language |\n| --------------------------------------------------------------------- | -------- |\n| [C# SDK](https://github.com/eigr-labs/spawn-dotnet-sdk)               | C#       |\n| [Elixir](https://github.com/eigr/spawn/tree/main/spawn_sdk/spawn_sdk) | Elixir   |\n| [Go SDK](https://github.com/eigr/spawn-go-sdk)                        | Go       |\n| [Spring Boot SDK](https://github.com/eigr/spawn-springboot-sdk)       | Java     |\n| [NodeJS/Typescript SDK](https://github.com/eigr/spawn-node-sdk)       | Node     |\n| [Python SDK](https://github.com/eigr-labs/spawn-python-sdk)           | Python   |\n| [Rust SDK](https://github.com/eigr-labs/spawn-rust-sdk)               | Rust     |\n\n#","ref":"Spawn.html#module-sdks","title":"SDKs - Spawn","type":"module"},{"doc":"Spawn defines some custom Resources for the user to interact with the API for deploying Spawn artifacts in Kubernetes. We'll talk more about these CRDs in the Getting Started section but for now we'll list each of these resources below for a general understanding of the concepts:\n\n- **ActorSystem CRD:** The user must define the ActorSystem CRD before it attempts to\n  deploy any other Spawn features. In it, the user defines some general parameters for the\n  functioning of the actor cluster and the parameters of the persistent storage connection for a\n  given system. Multiple ActorSystems can be defined but remember that they must be\n  referenced equally in the Actor Host Functions. Examples of this CRD can be found in the\n  [examples/k8s folder](examples/k8s/simple/system.yaml).\n\n- **ActorHost CRD:** A ActorHost is a cluster member application. An ActorHost, by\n  definition, is a Kubernetes Deployment and will contain two containers, one containing the\n  Actor Host Function user application and another container for the Spawn proxy, which is\n  responsible for connecting to the proxies cluster via Distributed Erlang and also for providing\n  all the necessary abstractions for the functioning of the system such as state management,\n  activation, and passivation of actors, among other infrastructure tasks. Examples of this CRD\n  can be found in the [examples/k8s folder](examples/k8s/simple/host.yaml).\n\n- **Activator CRD:** Activator CRD defines any means of inputting supported events such as\n  queues, topics, HTTP, or grpc endpoints and maps these events to the appropriate actor to\n  handle them. Examples of this CRD can be found in the [examples/k8s\n  folder](examples/k8s/activators).","ref":"Spawn.html#module-custom-resources","title":"Custom Resources - Spawn","type":"module"},{"doc":"Statestores are the interface between the downstream storage/database system and the actor.\nThey are configured by the user via environment variables or by the ActorSystem CRD (see [Custom Resources section](#custom-resources)) and their sensitive data is [stored in kubernetes secrets](#getting-started).\n\nBelow is a list of common global settings for all Statestores. For more details check the [documentation](docs/statestore.md) for each supported Statestore.\n\n| Environment Variable        | CRD Attribute                        | Secret Property | Default Env Value | Default CRD Value | Mandatory | Possible Values                         |\n| --------------------------- | ------------------------------------ | --------------- | ----------------- | ----------------- | --------- | --------------------------------------- |\n|                             | spec.statestore.credentialsSecretRef |                 |                   |                   | Yes       |\n| PROXY_DATABASE_TYPE         | spec.statestore.type                 |                 |                   |                   | Yes       | see [documentation](docs/statestore.md) |\n| PROXY_DATABASE_NAME         |                                      | database        | eigr-functions-db | eigr-functions-db |           |\n| PROXY_DATABASE_USERNAME     |                                      | username        | admin             | admin             |           |\n| PROXY_DATABASE_SECRET       |                                      | password        | admin             | admin             |           |\n| PROXY_DATABASE_HOST         |                                      | host            | localhost         | localhost         |           |\n| PROXY_DATABASE_PORT         |                                      | port            | adapter specific  | adapter specific  |           | see [documentation](docs/statestore.md) |\n| SPAWN_STATESTORE_KEY        |                                      | encryptionKey   |                   |                   | Yes       | openssl rand -base64 32                 |\n| PROXY_DATABASE_POOL_SIZE    | spec.statestore.pool.size            |                 | 60                | 60                |           |\n| PROXY_DATABASE_QUEUE_TARGET | spec.statestore.pool.queue           |                 | 10000             | 10000             |           |\n| PROXY_DATABASE_SSL          | spec.statestore.ssl                  |                 | false             | false             |           |\n| PROXY_DATABASE_SSL_VERIFY   | spec.statestore.ssl_verify           |                 | false             | false             |           |\n\n> **_NOTE:_** When running on top of Kubernetes you only need to set the CRD attributes of ActorSystem and Kubernetes secrets. The Operator will set the values of the environment variables according to the settings of these two mentioned places.","ref":"Spawn.html#module-statestores","title":"Statestores - Spawn","type":"module"},{"doc":"> **_NOTE:_** All scripts will use a MySQL DB with a database called eigr-functions-db by default. Make sure you have a working instance on your localhost or you will have to change make tasks or run commands manually during testing.\n\nTests:\n\n```shell\nmake test\n```\n\nRun:\n\n```shell\nmake build run-proxy-local\n```\n\nFor more information on how to collaborate or even to get to know the project structure better, go to our [contributor guide](CONTRIBUTING.md)","ref":"Spawn.html#module-local-development","title":"Local Development - Spawn","type":"module"},{"doc":"The sections below will discuss the main concepts that guided our architectural choices.\n\n#","ref":"Spawn.html#module-main-concepts","title":"Main Concepts - Spawn","type":"module"},{"doc":"Spawn is based on [Protocol Buffers](https://developers.google.com/protocol-buffers) and a\nsuper simple [HTTP stack](https://github.com/eigr/spawn/blob/main/docs/protocol.md)\nto allow a heterogeneous layer of communication between different services which can, in\nturn, be implemented in any language that supports the gRPC protocol.\n\nThe Spawn protocol itself is described [here](https://github.com/eigr/spawn/blob/main/priv/protos/eigr/functions/protocol/actors/protocol.proto).\n\n#","ref":"Spawn.html#module-the-protocol","title":"The Protocol - Spawn","type":"module"},{"doc":"According to [Wikipedia](https://en.wikipedia.org/wiki/Wikip%C3%A9dia:P%C3%A1gina_principal) Actor Model is:\n\n\"A mathematical model of concurrent computation that treats actor as the universal primitive of concurrent computation. In response to a message it receives, an actor can: [make local decisions, create more actors, send more messages, and determine how to respond to the next message received](https://www.youtube.com/watch?v=7erJ1DV_Tlo&t=22s). Actors may modify their own private state, but can only affect each other indirectly through messaging (removing the need for lock-based synchronization).\n\nThe actor model originated in [1973](https://www.ijcai.org/Proceedings/73/Papers/027B.pdf). It has been used both as a framework for a theoretical understanding of computation and as the theoretical basis for several practical implementations of concurrent systems.\"\n\nThe Actor Model was proposed by Carl Hewitt, Peter Bishop, and Richard Steiger and is\ninspired by several characteristics of the physical world.\n\nAlthough it emerged in the 70s of the last century, only in the previous two decades of our\ncentury has this model gained strength in the software engineering communities due to the\nmassive amount of existing data and the performance and distribution requirements of the\nmost current applications.\n\nFor more information about the Actor Model, see the following links:\n\nhttps://en.wikipedia.org/wiki/Actor_model\n\nhttps://codesync.global/media/almost-actors-comparing-pony-language-to-beam-languages-erlang-elixir/\n\nhttps://www.infoworld.com/article/2077999/understanding-actor-concurrency--part-1--actors-in-erlang.html\n\nhttps://doc.akka.io/docs/akka/current/general/actors.html\n\n#","ref":"Spawn.html#module-the-actor-model","title":"The Actor Model - Spawn","type":"module"},{"doc":"The sidecar pattern is a pattern for implementing Service Meshs and Microservices\narchitectures where an external software is placed close to the real service to provide non-\nfunctional characteristics such as interfacing with the underlying network, routing, and data\ntransformation between other orthogonal requirements to the business.\n\nThe sidecar allows components to access services from any location or programming language.\nThe sidecar can also be a translator for cross-language dependency management as a\ncommunication proxy mechanism. This benefits distributed applications with complex\nintegration requirements and applications that rely on external business integrations.\n\nFor more information about the Sidecar Pattern, see the following links:\n\nhttps://www.techtarget.com/searchapparchitecture/tip/The-role-of-sidecars-in-microservices-architecture\n\nhttps://docs.microsoft.com/en-us/azure/architecture/patterns/sidecar\n\nhttps://www.youtube.com/watch?v=j7JKkbAiWuI\n\nhttps://medium.com/nerd-for-tech/microservice-design-pattern-sidecar-sidekick-pattern-dbcea9bed783\n\n#","ref":"Spawn.html#module-the-sidecar-pattern","title":"The Sidecar Pattern - Spawn","type":"module"},{"doc":"We use [Nats](https://nats.io/) for communication between different systems like Activators or cross ActorSystems. According to the project page \"NATS is a simple, secure and performant communications system for digital systems, services and devices. NATS is part of the Cloud Native Computing Foundation (CNCF). NATS has over 40 client language implementations, and its server can run on-premise, in the cloud, at the edge, and even on a Raspberry Pi. NATS can secure and simplify design and operation of modern distributed systems.\"\n\nNats' ability to natively implement different topologies, as well as its minimalism, its cloud-native nature, and its capabilities to run on more constrained devices is what made us use Nats over other solutions. Nats allows Spawn to be able to provide strong isolation from an ActorSystem without limiting the user, allowing the user to still be able to communicate securely between different ActorSystems. Nats also facilitates the implementation of our triggers, called Activators, allowing those even without being part of an Erlang cluster to be able to invoke any actors.","ref":"Spawn.html#module-nats","title":"Nats - Spawn","type":"module"},{"doc":"","ref":"Spawn.Cache.LookupCache.html","title":"Spawn.Cache.LookupCache","type":"module"},{"doc":"A convenience function for getting the primary storage cache.","ref":"Spawn.Cache.LookupCache.html#__primary__/0","title":"Spawn.Cache.LookupCache.__primary__/0","type":"function"},{"doc":"A convenience function to get the node of the given `key`.","ref":"Spawn.Cache.LookupCache.html#get_node/1","title":"Spawn.Cache.LookupCache.get_node/1","type":"function"},{"doc":"A convenience function for joining the cache to the cluster.","ref":"Spawn.Cache.LookupCache.html#join_cluster/0","title":"Spawn.Cache.LookupCache.join_cluster/0","type":"function"},{"doc":"A convenience function for removing the cache from the cluster.","ref":"Spawn.Cache.LookupCache.html#leave_cluster/0","title":"Spawn.Cache.LookupCache.leave_cluster/0","type":"function"},{"doc":"A convenience function for getting the cluster nodes.","ref":"Spawn.Cache.LookupCache.html#nodes/0","title":"Spawn.Cache.LookupCache.nodes/0","type":"function"},{"doc":"This is the cache for the primary storage.","ref":"Spawn.Cache.LookupCache.Primary.html","title":"Spawn.Cache.LookupCache.Primary","type":"module"},{"doc":"A convenience function for retrieving the current generations.","ref":"Spawn.Cache.LookupCache.Primary.html#generations/0","title":"Spawn.Cache.LookupCache.Primary.generations/0","type":"function"},{"doc":"A convenience function for creating new generations.","ref":"Spawn.Cache.LookupCache.Primary.html#new_generation/1","title":"Spawn.Cache.LookupCache.Primary.new_generation/1","type":"function"},{"doc":"A convenience function for retrieving the newer generation.","ref":"Spawn.Cache.LookupCache.Primary.html#newer_generation/0","title":"Spawn.Cache.LookupCache.Primary.newer_generation/0","type":"function"},{"doc":"A convenience function for reset the GC timer.","ref":"Spawn.Cache.LookupCache.Primary.html#reset_generation_timer/0","title":"Spawn.Cache.LookupCache.Primary.reset_generation_timer/0","type":"function"},{"doc":"","ref":"Spawn.Cluster.Node.Client.html","title":"Spawn.Cluster.Node.Client","type":"module"},{"doc":"Defines a distributed registry for all process","ref":"Spawn.Cluster.Node.Registry.html","title":"Spawn.Cluster.Node.Registry","type":"module"},{"doc":"","ref":"Spawn.Cluster.Node.Registry.html#child_spec/0","title":"Spawn.Cluster.Node.Registry.child_spec/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.\nSee `Supervisor`.","ref":"Spawn.Cluster.Node.Registry.html#child_spec/1","title":"Spawn.Cluster.Node.Registry.child_spec/1","type":"function"},{"doc":"Check if Process is alive.","ref":"Spawn.Cluster.Node.Registry.html#is_alive?/2","title":"Spawn.Cluster.Node.Registry.is_alive?/2","type":"function"},{"doc":"List all alive PIDs from given registry module.","ref":"Spawn.Cluster.Node.Registry.html#list_actor_pids/1","title":"Spawn.Cluster.Node.Registry.list_actor_pids/1","type":"function"},{"doc":"Get Process if this is alive.","ref":"Spawn.Cluster.Node.Registry.html#lookup/2","title":"Spawn.Cluster.Node.Registry.lookup/2","type":"function"},{"doc":"Update value meta inside registry","ref":"Spawn.Cluster.Node.Registry.html#update_entry_value/4","title":"Spawn.Cluster.Node.Registry.update_entry_value/4","type":"function"},{"doc":"Node subscriber","ref":"Spawn.Cluster.Node.Server.html","title":"Spawn.Cluster.Node.Server","type":"module"},{"doc":"","ref":"Spawn.Cluster.Node.Server.html#error/2","title":"Spawn.Cluster.Node.Server.error/2","type":"function"},{"doc":"","ref":"Spawn.Cluster.Node.Server.html#request/1","title":"Spawn.Cluster.Node.Server.request/1","type":"function"},{"doc":"Behavior for managing the state of clustered processes a.k.a lookups.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour","type":"behaviour"},{"doc":"Cleanup action.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:clean/2","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.clean/2","type":"callback"},{"doc":"Fetch the ActorHost process reference by id.\nIn case `id` is the hash of the ActorId but here the struct ActorId is passed as a parameter.\nAn implementations must handle this.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:get_by_id/2","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.get_by_id/2","type":"callback"},{"doc":"Any procedure to be executed after the StateHandoffManager is initialized.\nExecuted during callback call to handle_continue.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_after_init/1","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_after_init/1","type":"callback"},{"doc":"Any initialization code required by implementations of this behavior.\nMust return the state to be added in the StateHandoffManager.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_init/1","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_init/1","type":"callback"},{"doc":"If necessary any procedure to be executed during a nodedown event","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_nodedown_event/3","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_nodedown_event/3","type":"callback"},{"doc":"If necessary any procedure to be executed during a nodeup event","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_nodeup_event/3","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_nodeup_event/3","type":"callback"},{"doc":"Perform any necessary cleanups during StateHandoffManager termination.\nGenerally excluding references to all processes owned by the terminating node.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_terminate/2","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_terminate/2","type":"callback"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:handle_timer/2","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.handle_timer/2","type":"callback"},{"doc":"Adds a reference to an ActorHost process.","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#c:set/4","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.set/4","type":"callback"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:config/0","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.config/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:data/0","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.data/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:host/0","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.host/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:hosts/0","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.hosts/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:id/0","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.id/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:new_data/0","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.new_data/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:node_type/0","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.node_type/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.ControllerBehaviour.html#t:timer/0","title":"Spawn.Cluster.StateHandoff.ControllerBehaviour.timer/0","type":"type"},{"doc":"This handles state handoff in a cluster.\n\nIt uses the DeltaCrdt library to handle a distributed state, which is an eventually consistent replicated data type.\nThe module starts a GenServer that monitors nodes in the cluster, and when a new node comes up it sends a \"set_neighbours\"\nmessage to that node's GenServer process with its own DeltaCrdt process ID. This is done to ensure that changes in either node's\nstate are reflected across both.\n\nThe module also handles other messages like \"handoff\" and \"get\" to put and retrieve data from the DeltaCrdt state, respectively.","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController","type":"module"},{"doc":"Cluster HostActor cleanup","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#clean/2","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.clean/2","type":"function"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#get_crdt_pid/0","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.get_crdt_pid/0","type":"function"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:config/0","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.config/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:data/0","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.data/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:host/0","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.host/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:hosts/0","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.hosts/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:id/0","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.id/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:new_data/0","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.new_data/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:node_type/0","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.node_type/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.html#t:timer/0","title":"Spawn.Cluster.StateHandoff.Controllers.CrdtController.timer/0","type":"type"},{"doc":"`StateHandoffPersistentController` is a StateHandoff Controller basead on `Statestore` mechanism.","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController","type":"module"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:config/0","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.config/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:data/0","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.data/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:host/0","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.host/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:hosts/0","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.hosts/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:id/0","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.id/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:new_data/0","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.new_data/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:node_type/0","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.node_type/0","type":"type"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.html#t:timer/0","title":"Spawn.Cluster.StateHandoff.Controllers.PersistentController.timer/0","type":"type"},{"doc":"This handles state handoff in a cluster.\n\nThis module monitors node up and down events as well as node terminate events and triggers `Spawn.Cluster.StateHandoff.ControllerBehaviour` implementations to handle these events.","ref":"Spawn.Cluster.StateHandoff.Manager.html","title":"Spawn.Cluster.StateHandoff.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Spawn.Cluster.StateHandoff.Manager.html#child_spec/1","title":"Spawn.Cluster.StateHandoff.Manager.child_spec/1","type":"function"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Manager.html#child_spec/2","title":"Spawn.Cluster.StateHandoff.Manager.child_spec/2","type":"function"},{"doc":"Cluster HostActor cleanup","ref":"Spawn.Cluster.StateHandoff.Manager.html#clean/1","title":"Spawn.Cluster.StateHandoff.Manager.clean/1","type":"function"},{"doc":"Pickup the stored entity data for a actor","ref":"Spawn.Cluster.StateHandoff.Manager.html#get/1","title":"Spawn.Cluster.StateHandoff.Manager.get/1","type":"function"},{"doc":"Store a actor and entity in the lookup store","ref":"Spawn.Cluster.StateHandoff.Manager.html#set/2","title":"Spawn.Cluster.StateHandoff.Manager.set/2","type":"function"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Manager.html#start_link/1","title":"Spawn.Cluster.StateHandoff.Manager.start_link/1","type":"function"},{"doc":"","ref":"Spawn.Cluster.StateHandoff.Manager.State.html","title":"Spawn.Cluster.StateHandoff.Manager.State","type":"module"},{"doc":"`AnySerializer` is responsible for serializing the protobuf type Any to Elixir\nstructures and vice versa.","ref":"Spawn.Utils.AnySerializer.html","title":"Spawn.Utils.AnySerializer","type":"module"},{"doc":"","ref":"Spawn.Utils.AnySerializer.html#any_pack!/1","title":"Spawn.Utils.AnySerializer.any_pack!/1","type":"function"},{"doc":"","ref":"Spawn.Utils.AnySerializer.html#any_unpack!/2","title":"Spawn.Utils.AnySerializer.any_unpack!/2","type":"function"},{"doc":"","ref":"Spawn.Utils.AnySerializer.html#json_any_pack!/1","title":"Spawn.Utils.AnySerializer.json_any_pack!/1","type":"function"},{"doc":"","ref":"Spawn.Utils.AnySerializer.html#pack_all_to_any/2","title":"Spawn.Utils.AnySerializer.pack_all_to_any/2","type":"function"},{"doc":"","ref":"Spawn.Utils.AnySerializer.html#unpack_any_bin/1","title":"Spawn.Utils.AnySerializer.unpack_any_bin/1","type":"function"},{"doc":"","ref":"Spawn.Utils.AnySerializer.html#unpack_unknown/1","title":"Spawn.Utils.AnySerializer.unpack_unknown/1","type":"function"},{"doc":"Error raised when the Actor already activated on another node.","ref":"Actors.Exceptions.NetworkPartitionException.html","title":"Actors.Exceptions.NetworkPartitionException","type":"exception"},{"doc":"","ref":"Actors.Exceptions.NetworkPartitionException.html#message/1","title":"Actors.Exceptions.NetworkPartitionException.message/1","type":"function"},{"doc":"Error raised when the Actor understands the request but refuses to authorize it.\n\nThis error should result in a http 403 status code.\nsee: https://developer.mozilla.org/en-US/docs/Web/HTTP/Status/403","ref":"Actors.Exceptions.NotAuthorizedException.html","title":"Actors.Exceptions.NotAuthorizedException","type":"exception"},{"doc":"","ref":"Actors.Exceptions.NotAuthorizedException.html#message/1","title":"Actors.Exceptions.NotAuthorizedException.message/1","type":"function"},{"doc":"# Spawn\n\n \n\n**Actor Mesh Serverless Platform**\n\n![ci](https://github.com/eigr/spawn/actions/workflows/ci.yaml/badge.svg) ![release](https://github.com/eigr/spawn/actions/workflows/release.yaml/badge.svg) ![last commit](https://img.shields.io/github/last-commit/eigr/spawn?style=social) [![join discord](https://badgen.net/badge/discord/Join%20Eigr%20on%20Discord/discord?icon=discord&label&color=blue)](https://discord.gg/2PcshvfS93) [![twitter](https://badgen.net/badge/twitter/Follow%20Eigr%20on%20Twitter/discord?icon=twitter&label&color=blue)](https://discord.gg/2PcshvfS93)\n\n### **[Website](https://eigr.io)** • **[Getting Started](#getting-started)** • **[SDKs](#sdks)** • **[Documentation](https://eigr.io/docs/projects-spawn/spawn-introduction/)** • **[Blog](https://eigr.io/blog/)**","ref":"readme.html","title":"Spawn","type":"extras"},{"doc":"**_What is Spawn?_**\n\nThere are two ways to answer this question, the short form would be something like:\n\n> \"Spawn is an Actor Model framework and Serverless Platform, which does a lot, really lot, of cool stuff that allows you to quickly deliver software oriented to your business domain.\"\n\nWell since this answer doesn't say much, let's go the long way.\n\nSpawn's main goal is to remove the complexity in developing microservices, providing simple and intuitive APIs, as well as a declarative deployment and configuration model and based on a Serverless architecture and Actor Model.\nThis leaves the developer to focus on developing the business domain while the platform deals with the complexities and infrastructure needed to support the scalable, resilient, distributed, and event-driven architecture that microservices-driven systems requires.\n\nSpawn is based on the sidecar proxy pattern to provide a polyglot Actor Model framework and platform.\nSpawn's technology stack, built on the [BEAM VM](https://www.erlang.org/blog/a-brief-beam-primer/) (Erlang's virtual machine) and [OTP](https://www.erlang.org/doc/design_principles/des_princ.html), provides support for different languages from its native Actor model.\n\nSpawn is made up of the following components:\n\n- A semantic protocol based on Protocol Buffers\n- A Sidecar Proxy, written in Elixir, that implements this protocol and persistent storage\n  adapters.\n- Support libraries in different programming languages.\n\nThese are the main concepts:\n\n1. **A Stateful Serverless Platform** running on top of Kubernetes, based on the Sidecar pattern and built on top of the BEAM VM.\n\n2. **Inversion of State**. This means that unlike conventional Serverless architectures where the developer fetches state from persistent storage we on the other hand send the state as the context of the event the function is receiving. Bringing state closer to computing.\n\n3. **Polyglot**. The platform must embrace as many software communities as possible. That's why the polyglot language model is adopted with SDK development for various programming languages.\n\n4. **Less Infrastructure**. This means that our platform will give the developer the tools to focus only on their business without worrying about issues such as:\n\n   - Resource allocation\n   - Definition of connections and Pools\n   - Service discovery\n   - Source/Sink of Events\n   - Other infrastructure issues\n\n5. **The basic primitive is the Actor** (from the actors model) and **_not_** the Function (from the traditional serverless architectures).\n\n6. Horizontal scalability with automatic **Activation** and **Deactivation** of Actors on demand.\n\nWatch the video explaining how it works:\n\n[![asciicast](https://asciinema.org/a/V2zUGsRmOjs0kI7swVTsKg7BQ.svg)](https://asciinema.org/a/V2zUGsRmOjs0kI7swVTsKg7BQ)\n\n> **_NOTE:_** This video was recorded with an old version of the SDK for Java. That's why errors are seen in Deployment","ref":"readme.html#overview","title":"Overview - Spawn","type":"extras"},{"doc":"The advancement of Cloud Computing, Edge computing, Containers, Orchestrators, Data-\nOriented Services, and global-scale products aimed at serving audiences in various regions of\nour world make the development of software today a task of enormous complexity. It is not\nuncommon to see dozens, if not hundreds, of non-functional requirements that must be met\nto build a system. All this complexity falls on the developer, who often does not have all the\nknowledge or time to create such systems satisfactorily.\n\nWhen studying this scenario, we realize that many of these current problems belong to the following groups:\n\n- Fast business oriented software delivery.\n- State management.\n- Scalability.\n- Resilience and fault tolerance.\n- Distributed and/or regionally distributed computing.\n- Integration Services.\n- Polyglot services.\n\nThe actor model on which Spawn is based can solve almost all the problems on this list, with\nScalability, resilience, fault tolerance, and state management by far the top success stories of\ndifferent known actor model implementations. So what we needed to do was add Integration\n\nServices, fast, business-oriented delivery, distributed computing, and polyglot services to the\nrecipe so we could revolutionize software development as we know it today.\n\nThat's precisely what we did with our platform called Eigr Functions Spawn.\n\nSpawn takes care of the entire infrastructure layer by abstracting all the complex issues that\nare not part of the business domain it is intended to address.\n\nParticularly domains such as game development, machine learning pipelines, complex event\nprocessing, real-time data ingestion, service integrations, financial or transactional services,\nand logistics are some of the domains that can be mastered by the Eigr Functions Spawn\nplatform.","ref":"readme.html#what-problem-spawn-solves","title":"What problem Spawn solves - Spawn","type":"extras"},{"doc":"Spawn takes the Actor Model's distribution, fault tolerance, and high concurrent capability in\nits most famous implementation, the BEAM Erlang VM implementation, and adds to the\nflexibility and dynamism that the sidecar pattern offers to build cross-platform and polyglot\nmicroservice-oriented architectures.\n\nTo achieve these goals, the Eigr Functions Spawn architecture is composed of the following components:\n\n![image info](docs/diagrams/spawn-architecture.jpg)\n\nAs seen above, the Eigr Functions Spawn platform architecture is separated into different components, each with its responsibility. We will detail the components below.\n\n- **k8s Operator:** Responsible for interacting with the Kubernetes API and coordinating the deployments of the other components. The user interacts with it using our specific CRDs ([Custom Resource Definitions](https://kubernetes.io/docs/concepts/extend-kubernetes/api-extension/custom-resources/)). We'll talk more about our CRDs later.\n\n- **Cloud Storage:** Despite not being directly part of the platform, it is worth mentioning here that Spawn uses user-defined persistent storage to store the state of its Actors. Different types of persistent storage can be used, such as relational databases such as MySQL, Postgres, among others. In the future, we will support other types of databases, both relational and non-relational.\n\n- **Activators:** Activators are applications responsible for ingesting data from external sources for certain user-defined actors and are configured through their own CRD. They are responsible for listening to a user-configured event and forward this event through a direct invocation to a specific target actor. Different types of Activators exist to consume events from other providers such as Google PubSub, RabbitMQ, Amazon SQS, etc.\n\n- **Actor Host Function:** The container where the user defines his actors and all the business logic of his actors around the state of these actors through a specific SDK for each supported programming language.\n\n- **Spawn Sidecar Proxy:** The centerpiece of the gear is our sidecar proxy; in turn it is responsible for managing the entire lifecycle of user-defined actors through our SDKs and also responsible for managing the state of these actors in persistent storage. The Spawn proxy can also allow the user to develop different integration flows between its actors such as Forwards,\n  Effects, Pipes, and in the future, other essential standards such as Saga, Aggregators, Scatter-\n  Gather, external invocations, and others.\n  Our proxy connects directly and transparently to all cluster members without needing for a single point of failure, i.e., a true mesh network.\n\nAs we use Kubernetes to orchestrate our workloads through our Operator each user application will be summarized at the end there is a POD which is the smallest measure of workload present in kubernetes. Below is an image of how the components are grouped inside a POD in Kubernetes:\n\n![image info](docs/diagrams/spawn-pod-internals.jpg)\n\nIn turn, each Sidecar container within a POD organizes itself to form an Erlang cluster for each ActorSystem. Different ActorSystems can coexist in the same Kubernetes cluster and these in turn communicate cross ActorSystem using a Nats Broker as a transport mechanism via message passing. In this way we can granulate a large system into smaller parts, forming small Erlang clusters that still manage to maintain the behavior of a larger cluster depending on how the developer organizes its deployable units.","ref":"readme.html#spawn-architecture","title":"Spawn Architecture - Spawn","type":"extras"},{"doc":"- [x] Distribution. Automatic and transparent cluster formation via Kubernetes Operator.\n  - [x] Erlang Distributed as transport.\n    - [x] mTLS Support with Erlang Dist.\n    - [x] Automatic renewal of certificates.\n  - [x] Cross ActorSystem invocation Nats distribution.\n- [x] Configuration management via Kubernetes [CRDs](https://kubernetes.io/docs/tasks/extend-kubernetes/custom-resources/custom-resource-definitions/) and Envinronment Variables.\n- [x] Statestores. Adapters for persistent storage using multiple database providers.\n  - [x] Sqlite\n  - [x] MySql\n  - [x] Postgres\n  - [x] CockroachDB\n  - [x] MSSQL\n  - [ ] Native via Mnesia\n- [x] Automatic activation and deactivation of Actors.\n- [x] Horizontal Scalability\n  - [x] automatically controlled by the Operator using Kubernetes HPA based on memory and cpu.\n  - [ ] automatically controlled by the Operator via Internal Metrics.\n  - [ ] automatically controlled by the Operator via Custom Metrics.\n- [x] Workflows\n  - [x] Broadcast. Communicates with other actors through pubsub channel semantics.\n    - [x] In Memory broadcast. Using [Phoenix.PubSub](https://github.com/phoenixframework/phoenix_pubsub) as transport.\n    - [x] Nats broadcast. Using [Nats](https://nats.io/) as transport.\n  - [x] External Broadcast. Sends events with pubsub semantics outside the actor system using the same transport types as Broadcast.\n  - [x] Forwards. Forwards the input parameter of an action of an actor as input to another action of another actor.\n  - [x] Pipes. Forwards the output type of an action of one actor to the input of an action of another actor. Like Unix pipes.\n  - [x] Side effects. Sends an effect as a result of your computation for other Actors to handle.\n  - [ ] Saga.\n- [x] SDKs\n  - [x] Elixir. All features implemented.\n  - [x] Node/Typescript. All features implemented.\n  - [x] Java. Partially implemented.\n  - [ ] Python. Under development.\n  - [ ] Go. Under development.\n  - [ ] Rust. Under development.\n  - [ ] .Net/C#. Under development.\n- [x] Activators\n  - [x] CronJob Scheduler.\n  - [x] gRPC/HTTP.\n    - [x] Unary. Under development.\n    - [ ] Stream In.\n    - [ ] Stream Out.\n    - [ ] Bid Streamed.\n  - [x] RabbitMQ.\n  - [ ] Kafka.\n  - [ ] Amazon SQS.\n  - [ ] Google PubSub.\n- [x] Observability\n  - [x] OTLP Tracing.\n  - [x] Prometheus Metrics.\n- [x] Secucrity\n  - [x] Database encryption with AES-ACM-V1.\n  - [ ] Actor ACL (Access Control List). Under development.\n  - [ ] Actor invocation with Authentication/Authorization Basic Auth flow. Under development.\n  - [ ] Actor invocation with Authentication/Authorization JWT Auth flow. Under development.","ref":"readme.html#features","title":"Features - Spawn","type":"extras"},{"doc":"The recommended way to install Spawn is via our Kubernetes Operator.\n\n#","ref":"readme.html#install","title":"Install - Spawn","type":"extras"},{"doc":"- Kubernetes Cluster\n- Nats broker accessible within the cluster (See the note below).\n\n> **_Important:_** Nats broker is only necessary if you want to use the Activators feature or if you need your actors to communicate between different ActorSystems.\n\n#","ref":"readme.html#prerequisites","title":"Prerequisites - Spawn","type":"extras"},{"doc":"To install you need to download the Operator manifest file. The following command shows how this could be done directly via the command line:\n\n```shell\nkubectl create ns eigr-functions && curl -L https://github.com/eigr/spawn/releases/download/{release-version}/manifest.yaml | kubectl apply -f -\n```\n\n> **_NOTE:_** You need to inform the desired release version. For example:\n\n```shell\nkubectl create ns eigr-functions && curl -L https://github.com/eigr/spawn/releases/download/v1.0.0-rc16/manifest.yaml | kubectl apply -f -\n```","ref":"readme.html#instructions","title":"Instructions - Spawn","type":"extras"},{"doc":"First we must develop our HostFunction. Look for the documentation for [each SDK](#sdks) to know how to proceed but below are some examples:\n\n- [Using Elixir SDK](./spawn_sdk/spawn_sdk#installation)\n- [Using Java SDK](https://github.com/eigr/spawn-springboot-sdk/blob/main/README.md#installation)\n- [Using NodeJS SDK](https://github.com/eigr/spawn-node-sdk#installation)\n\nHaving our container created and containing our Actor Host Function (following above SDK recommendations), we must deploy\nit in a Kubernetes cluster with the Spawn Controller installed (See more about this\nprocess in the section on installation).\n\nIn this tutorial we are going to use a MySql database. In this case, in order for Spawn to know how to connect to the database instance, it is first necessary to create a kubernetes secret in same namespace you installed the Spawn Operator with the connection data and other parameters. Example:\n\n```shell\nkubectl create secret generic mysql-connection-secret -n eigr-functions \\\n  --from-literal=database=eigr-functions-db \\\n  --from-literal=host='mysql' \\\n  --from-literal=port='3306' \\\n  --from-literal=username='admin' \\\n  --from-literal=password='admin' \\\n  --from-literal=encryptionKey=$(openssl rand -base64 32)\n```\n\nSapwn securely encrypts the Actors' State, so the **_encryptionKey_** item must be informed and must be a key of reasonable size and complexity to ensure the security of your data.\n\n> **_NOTE:_** To learn more about Statestores settings, see the [statestore section](#statestores).\n\nIf you are going to use the Activators resource in your project or if you want your Actors to be able to communicate between different ActorSystems then you will need to create a secret with the connection information with the Nats server. See an example of how to do this below:\n\n> **_NOTICE:_** It is not within the scope of this tutorial to install Nats but a simple way to do it in kubernetes is in to run these commands: **helm repo add nats https://nats-io.github.io/k8s/helm/charts/ && helm install spawn-nats nats/nats**.\n\nNow create the config file with the Nats credentials:\n\n```\nkubectl -n default create secret generic nats-invocation-conn-secret \\\n  --from-literal=url=\"nats://spawn-nats:4222\" \\\n  --from-literal=authEnabled=\"false\" \\\n  --from-literal=tlsEnabled=\"false\" \\\n  --from-literal=username=\"\" \\\n  --from-literal=password=\"\"\n```\n\nNow in a directory of your choice, create a file called **_system.yaml_** with the following content:\n\n```yaml\n---\napiVersion: spawn-eigr.io/v1\nkind: ActorSystem\nmetadata:\n  name: spawn-system # Mandatory. Name of the ActorSystem\n  namespace: default # Optional. Default namespace is \"default\"\nspec:\n  # This externalInvocation section is necessary only if Nats broker is used in your project.\n  externalInvocation:\n    enabled: \"true\"\n    externalConnectorRef: nats-invocation-conn-secret\n  statestore:\n    type: MySql # Valid are [MySql, Postgres, Sqlite, MSSQL, CockroachDB]\n    credentialsSecretRef: mysql-connection-secret # The secret containing connection params created in the previous step.\n    pool: # Optional\n      size: \"10\"\n```\n\nThis file will be responsible for creating a system of actors in the cluster.\n\nNow create a new file called **_host.yaml_** with the following content:\n\n```yaml\n---\napiVersion: spawn-eigr.io/v1\nkind: ActorHost\nmetadata:\n  name: spawn-springboot-example # Mandatory. Name of the Node containing Actor Host Functions\n  namespace: default # Optional. Default namespace is \"default\"\n  annotations:\n    # Mandatory. Name of the ActorSystem declared in ActorSystem CRD\n    spawn-eigr.io/actor-system: spawn-system\nspec:\n  host:\n    image: eigr/spawn-springboot-examples:latest # Mandatory\n    ports:\n      - name: \"http\"\n        containerPort: 8091\n```\n\nThis file will be responsible for deploying your host function and actors in the cluster.\nBut if you are using the SDK for Elixir then your Yaml should look like this:\n\n```yaml\n---\napiVersion: spawn-eigr.io/v1\nkind: ActorHost\nmetadata:\n  name: spawn-dice-game\n  namespace: default\n    spawn-eigr.io/actor-system: spawn-system\nspec:\n  host:\n    embedded: true # This indicates that it is a native BEAM application and therefore does not need a sidecar proxy attached.\n    image: eigr/dice-game-example:0.5.3\n    ports:\n      - name: \"http\"\n        containerPort: 8800\n```\n\nNow that the files have been defined, we can apply them to the cluster:\n\n```shell\nkubectl apply -f system.yaml\nkubectl apply -f host.yaml\n```\n\nAfter that, just check your actors with:\n\n```shell\nkubectl get actorhosts\n```\n\n#","ref":"readme.html#getting-started","title":"Getting Started - Spawn","type":"extras"},{"doc":"You can find some examples of using Spawn in the links below:\n\n- **Hatch**: https://github.com/zblanco/hatch\n- **Elixir Dice Game. Spawn with Phoenix app**: https://github.com/eigr-labs/spawn_game_example.git\n- **Distributed Image Processing**: https://github.com/eigr-labs/spawn-distributed-image-processing\n- **Federated Data Example**: https://github.com/eigr-labs/spawn-federated-data-example\n- **Fleet**: https://github.com/sleipnir/fleet-spawn-example\n- **Spawn Polyglot Example**: https://github.com/sleipnir/spawn-polyglot-ping-pong\n\n#","ref":"readme.html#examples","title":"Examples - Spawn","type":"extras"},{"doc":"You can see some talks on Youtube about Eigr Community or Spawn in the links below:\n\n- **Marcel Lanz on Code Beam Europe 2022**: https://youtu.be/jgR7Oc_GXAg\n- **Adriano Santos on Code Beam BR 2022**: Link not yet released by the event organizers","ref":"readme.html#talks","title":"Talks - Spawn","type":"extras"},{"doc":"Another important part of Spawn is the SDKs implemented in different languages that aim to\nabstract all the protocol specifics and expose an easy and intuitive API to developers.\n\n| SDK                                                                   | Language |\n| --------------------------------------------------------------------- | -------- |\n| [C# SDK](https://github.com/eigr-labs/spawn-dotnet-sdk)               | C#       |\n| [Elixir](https://github.com/eigr/spawn/tree/main/spawn_sdk/spawn_sdk) | Elixir   |\n| [Go SDK](https://github.com/eigr/spawn-go-sdk)                        | Go       |\n| [Spring Boot SDK](https://github.com/eigr/spawn-springboot-sdk)       | Java     |\n| [NodeJS/Typescript SDK](https://github.com/eigr/spawn-node-sdk)       | Node     |\n| [Python SDK](https://github.com/eigr-labs/spawn-python-sdk)           | Python   |\n| [Rust SDK](https://github.com/eigr-labs/spawn-rust-sdk)               | Rust     |\n\n#","ref":"readme.html#sdks","title":"SDKs - Spawn","type":"extras"},{"doc":"Spawn defines some custom Resources for the user to interact with the API for deploying Spawn artifacts in Kubernetes. We'll talk more about these CRDs in the Getting Started section but for now we'll list each of these resources below for a general understanding of the concepts:\n\n- **ActorSystem CRD:** The user must define the ActorSystem CRD before it attempts to\n  deploy any other Spawn features. In it, the user defines some general parameters for the\n  functioning of the actor cluster and the parameters of the persistent storage connection for a\n  given system. Multiple ActorSystems can be defined but remember that they must be\n  referenced equally in the Actor Host Functions. Examples of this CRD can be found in the\n  [examples/k8s folder](examples/k8s/simple/system.yaml).\n\n- **ActorHost CRD:** A ActorHost is a cluster member application. An ActorHost, by\n  definition, is a Kubernetes Deployment and will contain two containers, one containing the\n  Actor Host Function user application and another container for the Spawn proxy, which is\n  responsible for connecting to the proxies cluster via Distributed Erlang and also for providing\n  all the necessary abstractions for the functioning of the system such as state management,\n  activation, and passivation of actors, among other infrastructure tasks. Examples of this CRD\n  can be found in the [examples/k8s folder](examples/k8s/simple/host.yaml).\n\n- **Activator CRD:** Activator CRD defines any means of inputting supported events such as\n  queues, topics, HTTP, or grpc endpoints and maps these events to the appropriate actor to\n  handle them. Examples of this CRD can be found in the [examples/k8s\n  folder](examples/k8s/activators).","ref":"readme.html#custom-resources","title":"Custom Resources - Spawn","type":"extras"},{"doc":"Statestores are the interface between the downstream storage/database system and the actor.\nThey are configured by the user via environment variables or by the ActorSystem CRD (see [Custom Resources section](#custom-resources)) and their sensitive data is [stored in kubernetes secrets](#getting-started).\n\nBelow is a list of common global settings for all Statestores. For more details check the [documentation](docs/statestore.md) for each supported Statestore.\n\n| Environment Variable        | CRD Attribute                        | Secret Property | Default Env Value | Default CRD Value | Mandatory | Possible Values                         |\n| --------------------------- | ------------------------------------ | --------------- | ----------------- | ----------------- | --------- | --------------------------------------- |\n|                             | spec.statestore.credentialsSecretRef |                 |                   |                   | Yes       |\n| PROXY_DATABASE_TYPE         | spec.statestore.type                 |                 |                   |                   | Yes       | see [documentation](docs/statestore.md) |\n| PROXY_DATABASE_NAME         |                                      | database        | eigr-functions-db | eigr-functions-db |           |\n| PROXY_DATABASE_USERNAME     |                                      | username        | admin             | admin             |           |\n| PROXY_DATABASE_SECRET       |                                      | password        | admin             | admin             |           |\n| PROXY_DATABASE_HOST         |                                      | host            | localhost         | localhost         |           |\n| PROXY_DATABASE_PORT         |                                      | port            | adapter specific  | adapter specific  |           | see [documentation](docs/statestore.md) |\n| SPAWN_STATESTORE_KEY        |                                      | encryptionKey   |                   |                   | Yes       | openssl rand -base64 32                 |\n| PROXY_DATABASE_POOL_SIZE    | spec.statestore.pool.size            |                 | 60                | 60                |           |\n| PROXY_DATABASE_QUEUE_TARGET | spec.statestore.pool.queue           |                 | 10000             | 10000             |           |\n| PROXY_DATABASE_SSL          | spec.statestore.ssl                  |                 | false             | false             |           |\n| PROXY_DATABASE_SSL_VERIFY   | spec.statestore.ssl_verify           |                 | false             | false             |           |\n\n> **_NOTE:_** When running on top of Kubernetes you only need to set the CRD attributes of ActorSystem and Kubernetes secrets. The Operator will set the values of the environment variables according to the settings of these two mentioned places.","ref":"readme.html#statestores","title":"Statestores - Spawn","type":"extras"},{"doc":"> **_NOTE:_** All scripts will use a MySQL DB with a database called eigr-functions-db by default. Make sure you have a working instance on your localhost or you will have to change make tasks or run commands manually during testing.\n\nTests:\n\n```shell\nmake test\n```\n\nRun:\n\n```shell\nmake build run-proxy-local\n```\n\nFor more information on how to collaborate or even to get to know the project structure better, go to our [contributor guide](CONTRIBUTING.md)","ref":"readme.html#local-development","title":"Local Development - Spawn","type":"extras"},{"doc":"The sections below will discuss the main concepts that guided our architectural choices.\n\n#","ref":"readme.html#main-concepts","title":"Main Concepts - Spawn","type":"extras"},{"doc":"Spawn is based on [Protocol Buffers](https://developers.google.com/protocol-buffers) and a\nsuper simple [HTTP stack](https://github.com/eigr/spawn/blob/main/docs/protocol.md)\nto allow a heterogeneous layer of communication between different services which can, in\nturn, be implemented in any language that supports the gRPC protocol.\n\nThe Spawn protocol itself is described [here](https://github.com/eigr/spawn/blob/main/priv/protos/eigr/functions/protocol/actors/protocol.proto).\n\n#","ref":"readme.html#the-protocol","title":"The Protocol - Spawn","type":"extras"},{"doc":"According to [Wikipedia](https://en.wikipedia.org/wiki/Wikip%C3%A9dia:P%C3%A1gina_principal) Actor Model is:\n\n\"A mathematical model of concurrent computation that treats actor as the universal primitive of concurrent computation. In response to a message it receives, an actor can: [make local decisions, create more actors, send more messages, and determine how to respond to the next message received](https://www.youtube.com/watch?v=7erJ1DV_Tlo&t=22s). Actors may modify their own private state, but can only affect each other indirectly through messaging (removing the need for lock-based synchronization).\n\nThe actor model originated in [1973](https://www.ijcai.org/Proceedings/73/Papers/027B.pdf). It has been used both as a framework for a theoretical understanding of computation and as the theoretical basis for several practical implementations of concurrent systems.\"\n\nThe Actor Model was proposed by Carl Hewitt, Peter Bishop, and Richard Steiger and is\ninspired by several characteristics of the physical world.\n\nAlthough it emerged in the 70s of the last century, only in the previous two decades of our\ncentury has this model gained strength in the software engineering communities due to the\nmassive amount of existing data and the performance and distribution requirements of the\nmost current applications.\n\nFor more information about the Actor Model, see the following links:\n\nhttps://en.wikipedia.org/wiki/Actor_model\n\nhttps://codesync.global/media/almost-actors-comparing-pony-language-to-beam-languages-erlang-elixir/\n\nhttps://www.infoworld.com/article/2077999/understanding-actor-concurrency--part-1--actors-in-erlang.html\n\nhttps://doc.akka.io/docs/akka/current/general/actors.html\n\n#","ref":"readme.html#the-actor-model","title":"The Actor Model - Spawn","type":"extras"},{"doc":"The sidecar pattern is a pattern for implementing Service Meshs and Microservices\narchitectures where an external software is placed close to the real service to provide non-\nfunctional characteristics such as interfacing with the underlying network, routing, and data\ntransformation between other orthogonal requirements to the business.\n\nThe sidecar allows components to access services from any location or programming language.\nThe sidecar can also be a translator for cross-language dependency management as a\ncommunication proxy mechanism. This benefits distributed applications with complex\nintegration requirements and applications that rely on external business integrations.\n\nFor more information about the Sidecar Pattern, see the following links:\n\nhttps://www.techtarget.com/searchapparchitecture/tip/The-role-of-sidecars-in-microservices-architecture\n\nhttps://docs.microsoft.com/en-us/azure/architecture/patterns/sidecar\n\nhttps://www.youtube.com/watch?v=j7JKkbAiWuI\n\nhttps://medium.com/nerd-for-tech/microservice-design-pattern-sidecar-sidekick-pattern-dbcea9bed783\n\n#","ref":"readme.html#the-sidecar-pattern","title":"The Sidecar Pattern - Spawn","type":"extras"},{"doc":"We use [Nats](https://nats.io/) for communication between different systems like Activators or cross ActorSystems. According to the project page \"NATS is a simple, secure and performant communications system for digital systems, services and devices. NATS is part of the Cloud Native Computing Foundation (CNCF). NATS has over 40 client language implementations, and its server can run on-premise, in the cloud, at the edge, and even on a Raspberry Pi. NATS can secure and simplify design and operation of modern distributed systems.\"\n\nNats' ability to natively implement different topologies, as well as its minimalism, its cloud-native nature, and its capabilities to run on more constrained devices is what made us use Nats over other solutions. Nats allows Spawn to be able to provide strong isolation from an ActorSystem without limiting the user, allowing the user to still be able to communicate securely between different ActorSystems. Nats also facilitates the implementation of our triggers, called Activators, allowing those even without being part of an Erlang cluster to be able to invoke any actors.","ref":"readme.html#nats","title":"Nats - Spawn","type":"extras"}]}